
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 1.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "1.vec"
	.INCLUDE "1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 27/12/2009
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATmega16
;      17 Program type        : Application
;      18 Clock frequency     : 1.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 256
;      22 *****************************************************/
;      23 #include <mega16.h>
;      24 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      25 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      26 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      27 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      28 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      29 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      30 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      31 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      32 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      33 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      34 	#endif
	#endif
;      35 #include <stdio.h>
;      36 #include <delay.h>
;      37 // Alphanumeric LCD Module functions
;      38 #asm
;      39    .equ __lcd_port=0x15 ;PORTC
   .equ __lcd_port=0x15 ;PORTC
;      40 #endasm
;      41 #include <lcd.h>
;      42 unsigned char str[40];
_str:
	.BYTE 0x28
;      43 long int y,rpm,v,j,p,b,z,key=255,q=0,ki=4,kd=2,kp=4,pwm,scal=450,u,irpm=3500,CurSpd;
_y:
	.BYTE 0x4
_rpm:
	.BYTE 0x4
_v:
	.BYTE 0x4
_j:
	.BYTE 0x4
_p:
	.BYTE 0x4
_b:
	.BYTE 0x4
_z:
	.BYTE 0x4
_key:
	.BYTE 0x4
_q:
	.BYTE 0x4
_ki:
	.BYTE 0x4
_kd:
	.BYTE 0x4
_kp:
	.BYTE 0x4
_pwm:
	.BYTE 0x4
_scal:
	.BYTE 0x4
_u:
	.BYTE 0x4
_irpm:
	.BYTE 0x4
_CurSpd:
	.BYTE 0x4
;      44 unsigned char code[4][4]={{0,4,8,12},{1,5,9,13},{2,6,10,14},{3,7,11,15}};
_code:
	.BYTE 0x10
;      45 /////////////////////////////////////////
;      46 void PID(void);
;      47 // Timer 0 output compare interrupt service routine
;      48 /////////////////////////////////////////////////////////cunter  timer 000
;      49 interrupt [TIM0_COMP] void timer0_comp_isr(void)
;      50 {

	.CSEG
_timer0_comp_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      51 y++;
	LDS  R30,_y
	LDS  R31,_y+1
	LDS  R22,_y+2
	LDS  R23,_y+3
	__SUBD1N -1
	STS  _y,R30
	STS  _y+1,R31
	STS  _y+2,R22
	STS  _y+3,R23
;      52 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;      53 
;      54 // Timer 1 overflow interrupt service routine
;      55 /////////////////////////////////////////////////////////pwm timer  1111
;      56 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;      57 {
_timer1_ovf_isr:
	ST   -Y,R30
;      58  TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;      59  TCNT1L=0x82;
	LDI  R30,LOW(130)
	OUT  0x2C,R30
;      60  }
	LD   R30,Y+
	RETI
;      61 ////////////////////////////////////////////////////////////timer 2222
;      62 // Timer 2 overflow interrupt service routine
;      63 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;      64 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      65     static unsigned char rr;

	.DSEG

	.CSEG
;      66     rr=TCNT0;
	IN   R5,50
;      67     TCNT2=0x0A;
	LDI  R30,LOW(10)
	OUT  0x24,R30
;      68     TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;      69     rpm=(y*100+TCNT0)*24/10;
	LDS  R26,_y
	LDS  R27,_y+1
	LDS  R24,_y+2
	LDS  R25,_y+3
	__GETD1N 0x64
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	IN   R30,0x32
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD21
	__GETD1N 0x18
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __DIVD21
	STS  _rpm,R30
	STS  _rpm+1,R31
	STS  _rpm+2,R22
	STS  _rpm+3,R23
;      70     y=0;
	LDI  R30,0
	STS  _y,R30
	STS  _y+1,R30
	STS  _y+2,R30
	STS  _y+3,R30
;      71     TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;      72     rr=0;
	CLR  R5
;      73     TCCR0=0x0E;
	LDI  R30,LOW(14)
	OUT  0x33,R30
;      74     PID();
	RCALL _PID
;      75 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      76 
;      77 /////////////////////////////////////////////pid
;      78 
;      79 void PID(void)
;      80 {
_PID:
;      81         static long jahat=0,e0=0,e1=0,e2=0,e3=0;

	.DSEG
_jahat_S3:
	.BYTE 0x4
_e0_S3:
	.BYTE 0x4
_e1_S3:
	.BYTE 0x4
_e2_S3:
	.BYTE 0x4
_e3_S3:
	.BYTE 0x4

	.CSEG
;      82 
;      83         long k=0;
;      84         CurSpd =rpm;
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xA*2)
	LDI  R31,HIGH(_0xA*2)
	CALL __INITLOCB
;	k -> Y+0
	CALL SUBOPT_0x0
	STS  _CurSpd,R30
	STS  _CurSpd+1,R31
	STS  _CurSpd+2,R22
	STS  _CurSpd+3,R23
;      85         e3=e2;
	LDS  R30,_e2_S3
	LDS  R31,_e2_S3+1
	LDS  R22,_e2_S3+2
	LDS  R23,_e2_S3+3
	STS  _e3_S3,R30
	STS  _e3_S3+1,R31
	STS  _e3_S3+2,R22
	STS  _e3_S3+3,R23
;      86         e2=e1;
	CALL SUBOPT_0x1
	STS  _e2_S3,R30
	STS  _e2_S3+1,R31
	STS  _e2_S3+2,R22
	STS  _e2_S3+3,R23
;      87         e1=e0;
	CALL SUBOPT_0x2
	STS  _e1_S3,R30
	STS  _e1_S3+1,R31
	STS  _e1_S3+2,R22
	STS  _e1_S3+3,R23
;      88         e0 =irpm-CurSpd;
	LDS  R26,_CurSpd
	LDS  R27,_CurSpd+1
	LDS  R24,_CurSpd+2
	LDS  R25,_CurSpd+3
	CALL SUBOPT_0x3
	CALL __SUBD12
	STS  _e0_S3,R30
	STS  _e0_S3+1,R31
	STS  _e0_S3+2,R22
	STS  _e0_S3+3,R23
;      89         k=(kp*(e0+e1)+ki*(e0-e1)+(3*(e0-e2)+(e1-e3)*kd))/scal;
	CALL SUBOPT_0x1
	LDS  R26,_e0_S3
	LDS  R27,_e0_S3+1
	LDS  R24,_e0_S3+2
	LDS  R25,_e0_S3+3
	CALL __ADDD12
	LDS  R26,_kp
	LDS  R27,_kp+1
	LDS  R24,_kp+2
	LDS  R25,_kp+3
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R26,_e1_S3
	LDS  R27,_e1_S3+1
	LDS  R24,_e1_S3+2
	LDS  R25,_e1_S3+3
	CALL SUBOPT_0x2
	CALL __SUBD12
	LDS  R26,_ki
	LDS  R27,_ki+1
	LDS  R24,_ki+2
	LDS  R25,_ki+3
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R26,_e2_S3
	LDS  R27,_e2_S3+1
	LDS  R24,_e2_S3+2
	LDS  R25,_e2_S3+3
	CALL SUBOPT_0x2
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R26,_e3_S3
	LDS  R27,_e3_S3+1
	LDS  R24,_e3_S3+2
	LDS  R25,_e3_S3+3
	CALL SUBOPT_0x1
	CALL __SUBD12
	LDS  R26,_kd
	LDS  R27,_kd+1
	LDS  R24,_kd+2
	LDS  R25,_kd+3
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	CALL SUBOPT_0x4
	CALL __DIVD21
	__PUTD1S 0
;      90 
;      91         pwm = pwm + k;
	CALL SUBOPT_0x5
	CALL __ADDD12
	CALL SUBOPT_0x6
;      92 
;      93 
;      94         if(pwm>131)
	CALL SUBOPT_0x5
	__CPD2N 0x84
	BRLT _0xB
;      95         {
;      96             if(pwm>254)pwm=253;
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	BRLT _0xC
	__GETD1N 0xFD
	CALL SUBOPT_0x6
;      97             OCR1AL=pwm;
_0xC:
	LDS  R30,_pwm
	LDS  R31,_pwm+1
	LDS  R22,_pwm+2
	LDS  R23,_pwm+3
	OUT  0x2A,R30
;      98         }
;      99         if(pwm<131)
_0xB:
	CALL SUBOPT_0x5
	__CPD2N 0x83
	BRGE _0xD
;     100         {
;     101 
;     102            jahat=~jahat;
	CALL SUBOPT_0x8
	CALL __COMD1
	STS  _jahat_S3,R30
	STS  _jahat_S3+1,R31
	STS  _jahat_S3+2,R22
	STS  _jahat_S3+3,R23
;     103             if(jahat==0)PORTD=0X09;
	CALL SUBOPT_0x8
	CALL __CPD10
	BRNE _0xE
	LDI  R30,LOW(9)
	OUT  0x12,R30
;     104             if(jahat==1)PORTD=0X06;
_0xE:
	LDS  R26,_jahat_S3
	LDS  R27,_jahat_S3+1
	LDS  R24,_jahat_S3+2
	LDS  R25,_jahat_S3+3
	CALL SUBOPT_0x9
	BRNE _0xF
	LDI  R30,LOW(6)
	OUT  0x12,R30
;     105             OCR1AL=262-pwm;
_0xF:
	CALL SUBOPT_0x5
	__GETD1N 0x106
	CALL __SUBD12
	OUT  0x2A,R30
;     106         }
;     107 
;     108 }
_0xD:
	ADIW R28,4
	RET
;     109 
;     110  ///////////////////////////////////////////////key pad///////////////////////
;     111 
;     112  unsigned char scan_key(void)
;     113 {
_scan_key:
;     114 unsigned char i,data,num_key,temp,p;
;     115 num_key=0xff;
	CALL __SAVELOCR6
;	i -> R17
;	data -> R16
;	num_key -> R19
;	temp -> R18
;	p -> R21
	LDI  R19,LOW(255)
;     116 temp=0x70;
	LDI  R18,LOW(112)
;     117 for(i=0;i<4;i++)
	LDI  R17,LOW(0)
_0x11:
	CPI  R17,4
	BRSH _0x12
;     118 {
;     119 PORTA=temp;
	OUT  0x1B,R18
;     120 delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0xA
;     121 data=PINA&0X0F;
;     122 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0xA
;     123 data=PINA&0X0F;
;     124 if(data==0x07)num_key=code[0][i];
	CPI  R16,7
	BRNE _0x13
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_code)
	SBCI R31,HIGH(-_code)
	LD   R19,Z
;     125 if(data==0x0b)num_key=code[1][i];
_0x13:
	CPI  R16,11
	BRNE _0x14
	__POINTW2MN _code,4
	CALL SUBOPT_0xB
;     126 if(data==0x0d)num_key=code[2][i];
_0x14:
	CPI  R16,13
	BRNE _0x15
	__POINTW2MN _code,8
	CALL SUBOPT_0xB
;     127 if(data==0x0e)num_key=code[3][i];
_0x15:
	CPI  R16,14
	BRNE _0x16
	__POINTW2MN _code,12
	CALL SUBOPT_0xB
;     128 temp=((temp>>1)|0x80)&0xf0;
_0x16:
	MOV  R30,R18
	LSR  R30
	ORI  R30,0x80
	ANDI R30,LOW(0xF0)
	MOV  R18,R30
;     129 }
	SUBI R17,-1
	RJMP _0x11
_0x12:
;     130 return num_key;
	MOV  R30,R19
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;     131 }
;     132 //////////////////////
;     133  void keyin (void)
;     134  {
_keyin:
;     135    if(z>=0 && z<=9)
	CALL SUBOPT_0xC
	CALL __CPD20
	BRLT _0x18
	CALL SUBOPT_0xD
	BRLT _0x19
_0x18:
	RJMP _0x17
_0x19:
;     136         {
;     137                delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0xE
;     138                 b=z+b*10;
	LDS  R26,_b
	LDS  R27,_b+1
	LDS  R24,_b+2
	LDS  R25,_b+3
	__GETD1N 0xA
	CALL __MULD12
	CALL SUBOPT_0xC
	CALL __ADDD12
	STS  _b,R30
	STS  _b+1,R31
	STS  _b+2,R22
	STS  _b+3,R23
;     139 
;     140          }
;     141  }
_0x17:
	RET
;     142 /////////////
;     143 void main(void)
;     144 {
_main:
;     145 
;     146 // Declare your local variables here
;     147 
;     148 // Input/Output Ports initialization
;     149 // Port A initialization
;     150 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     151 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     152 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     153 DDRA=0xf0;
	LDI  R30,LOW(240)
	OUT  0x1A,R30
;     154 
;     155 // Port B initialization
;     156 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     157 // State7=P State6=P State5=P State4=P State3=T State2=T State1=T State0=T
;     158 PORTB=0xF0;
	OUT  0x18,R30
;     159 DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x17,R30
;     160 
;     161 // Port C initialization
;     162 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     163 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     164 PORTC=0x00;
	OUT  0x15,R30
;     165 DDRC=0x00;
	OUT  0x14,R30
;     166 
;     167 // Port D initialization
;     168 // Func7=Out Func6=Out Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
;     169 // State7=0 State6=0 State5=0 State4=T State3=0 State2=0 State1=0 State0=0
;     170 PORTD=0x09;
	LDI  R30,LOW(9)
	OUT  0x12,R30
;     171 DDRD=0xEF;
	LDI  R30,LOW(239)
	OUT  0x11,R30
;     172 
;     173 // Timer/Counter 0 initialization
;     174 // Clock source: T0 pin Rising Edge
;     175 // Mode: CTC top=OCR0
;     176 // OC0 output: Disconnected
;     177 TCCR0=0x0F;
	LDI  R30,LOW(15)
	OUT  0x33,R30
;     178 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     179 OCR0=0x63;
	LDI  R30,LOW(99)
	OUT  0x3C,R30
;     180 
;     181 // Timer/Counter 1 initialization
;     182 // Clock source: System Clock
;     183 // Clock value: 1000.000 kHz
;     184 // Mode: Fast PWM top=00FFh
;     185 // OC1A output: Non-Inv.
;     186 // OC1B output: Discon.
;     187 // Noise Canceler: Off
;     188 // Input Capture on Falling Edge
;     189 // Timer 1 Overflow Interrupt: On
;     190 // Input Capture Interrupt: Off
;     191 // Compare A Match Interrupt: Off
;     192 // Compare B Match Interrupt: Off
;     193 /*TCCR1A=0x81;
;     194 TCCR1B=0x09;
;     195 TCNT1H=0x00;
;     196 TCNT1L=0x37;
;     197 ICR1H=0x00;
;     198 ICR1L=0x00;
;     199 OCR1AH=0x00;
;     200 OCR1AL=0x3b;
;     201 OCR1BH=0x00;
;     202 OCR1BL=0x00;*/
;     203 ///////////////////
;     204 TCCR1A=0x81;
	LDI  R30,LOW(129)
	OUT  0x2F,R30
;     205 TCCR1B=0x0A;
	LDI  R30,LOW(10)
	OUT  0x2E,R30
;     206 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     207 TCNT1L=0x82;
	LDI  R30,LOW(130)
	OUT  0x2C,R30
;     208 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
;     209 ICR1L=0x00;
	OUT  0x26,R30
;     210 OCR1AH=0x00;
	OUT  0x2B,R30
;     211 OCR1AL=0xC8;
	LDI  R30,LOW(200)
	OUT  0x2A,R30
;     212 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     213 OCR1BL=0x00;
	OUT  0x28,R30
;     214 // Timer/Counter 2 initialization
;     215 // Clock source: System Clock
;     216 // Clock value: 0.977 kHz
;     217 // Mode: Normal top=FFh
;     218 // OC2 output: Disconnected
;     219 ASSR=0x00;
	OUT  0x22,R30
;     220 TCCR2=0x07;
	LDI  R30,LOW(7)
	OUT  0x25,R30
;     221 TCNT2=0x0A;
	LDI  R30,LOW(10)
	OUT  0x24,R30
;     222 OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     223 
;     224 // External Interrupt(s) initialization
;     225 // INT0: Off
;     226 // INT1: Off
;     227 // INT2: On
;     228 // INT2 Mode: Rising Edge
;     229 //GICR|=0x20;
;     230 MCUCR=0x00;
	OUT  0x35,R30
;     231 MCUCSR=0x00;
	OUT  0x34,R30
;     232 //GIFR=0x20;
;     233 
;     234 // Timer(s)/Counter(s) Interrupt(s) initialization
;     235 TIMSK=0x46;
	LDI  R30,LOW(70)
	OUT  0x39,R30
;     236 
;     237 // Analog Comparator initialization
;     238 // Analog Comparator: Off
;     239 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     240 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     241 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     242 
;     243 // LCD module initialization
;     244 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     245 
;     246 // Global enable interrupts
;     247 #asm("sei")
	sei
;     248 PORTD=0X09;
	LDI  R30,LOW(9)
	OUT  0x12,R30
;     249 while (1)
_0x1A:
;     250       {
;     251 
;     252      key=scan_key();
	CALL _scan_key
	CLR  R31
	CLR  R22
	CLR  R23
	STS  _key,R30
	STS  _key+1,R31
	STS  _key+2,R22
	STS  _key+3,R23
;     253 
;     254      switch(key)
	CALL SUBOPT_0xF
;     255        {
;     256           case 0 :z=16;
	BRNE _0x20
	__GETD1N 0x10
	RJMP _0x179
;     257           break;
;     258           case 1 :z=15;
_0x20:
	__CPD1N 0x1
	BRNE _0x21
	__GETD1N 0xF
	RJMP _0x179
;     259           break;
;     260           case 2 : z=12;
_0x21:
	__CPD1N 0x2
	BRNE _0x22
	__GETD1N 0xC
	RJMP _0x179
;     261           break;
;     262           case 3 : z=14;
_0x22:
	__CPD1N 0x3
	BRNE _0x23
	__GETD1N 0xE
	RJMP _0x179
;     263           break;
;     264           case 4 : z=13;
_0x23:
	__CPD1N 0x4
	BRNE _0x24
	__GETD1N 0xD
	RJMP _0x179
;     265           break;
;     266           case 5 :z=9;
_0x24:
	__CPD1N 0x5
	BRNE _0x25
	__GETD1N 0x9
	RJMP _0x179
;     267           break;
;     268           case 6 : z=6;
_0x25:
	__CPD1N 0x6
	BRNE _0x26
	__GETD1N 0x6
	RJMP _0x179
;     269           break;
;     270           case 7 : z=3;
_0x26:
	__CPD1N 0x7
	BRNE _0x27
	__GETD1N 0x3
	RJMP _0x179
;     271           break;
;     272           case 8 : z=0;
_0x27:
	__CPD1N 0x8
	BRNE _0x28
	LDI  R30,0
	STS  _z,R30
	STS  _z+1,R30
	STS  _z+2,R30
	STS  _z+3,R30
;     273           break;
	RJMP _0x1F
;     274           case 9 : z=8;
_0x28:
	__CPD1N 0x9
	BRNE _0x29
	__GETD1N 0x8
	RJMP _0x179
;     275           break;
;     276           case 10 : z=5;
_0x29:
	__CPD1N 0xA
	BRNE _0x2A
	__GETD1N 0x5
	RJMP _0x179
;     277           break;
;     278           case 11 : z=2;
_0x2A:
	__CPD1N 0xB
	BRNE _0x2B
	__GETD1N 0x2
	RJMP _0x179
;     279           break;
;     280           case 12 : z=11;
_0x2B:
	__CPD1N 0xC
	BRNE _0x2C
	__GETD1N 0xB
	RJMP _0x179
;     281           break;
;     282           case 13 : z=7;
_0x2C:
	__CPD1N 0xD
	BRNE _0x2D
	__GETD1N 0x7
	RJMP _0x179
;     283           break;
;     284           case 14 :z=4;
_0x2D:
	__CPD1N 0xE
	BRNE _0x2E
	__GETD1N 0x4
	RJMP _0x179
;     285           break;
;     286           case 15 :z=1;
_0x2E:
	__CPD1N 0xF
	BRNE _0x1F
	__GETD1N 0x1
_0x179:
	STS  _z,R30
	STS  _z+1,R31
	STS  _z+2,R22
	STS  _z+3,R23
;     287           break;
;     288       }
_0x1F:
;     289 
;     290       delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0xE
;     291      if(key!=0xff)
	CALL SUBOPT_0x10
	BREQ _0x30
;     292     {
;     293        delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	CALL SUBOPT_0xE
;     294        if(key!=0xff)keyin();
	CALL SUBOPT_0x10
	BREQ _0x31
	CALL _keyin
;     295      }
_0x31:
;     296 
;     297     /////////////// /////////////////////////////
;     298      if(key==4)q++;
_0x30:
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	BRNE _0x32
	CALL SUBOPT_0x13
	__SUBD1N -1
	STS  _q,R30
	STS  _q+1,R31
	STS  _q+2,R22
	STS  _q+3,R23
;     299      if(q==4)q=0;
_0x32:
	CALL SUBOPT_0x14
	CALL SUBOPT_0x12
	BRNE _0x33
	LDI  R30,0
	STS  _q,R30
	STS  _q+1,R30
	STS  _q+2,R30
	STS  _q+3,R30
;     300      if(q==0)
_0x33:
	CALL SUBOPT_0x13
	CALL __CPD10
	BRNE _0x34
;     301      {
;     302        lcd_gotoxy(0,0);
	CALL SUBOPT_0x15
;     303        sprintf(str,"pwm=%03d         rpm=%04d     ",OCR1AL,rpm,);
	CALL SUBOPT_0x16
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	IN   R30,0x2A
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	CALL SUBOPT_0x0
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
;     304        lcd_puts(str);
	CALL SUBOPT_0x16
	CALL _lcd_puts
;     305      }
;     306      /////////
;     307       if(q==1)
_0x34:
	CALL SUBOPT_0x14
	CALL SUBOPT_0x9
	BRNE _0x35
;     308      {
;     309         if(key==2) PORTD=0X09;
	CALL SUBOPT_0x17
	BRNE _0x36
	LDI  R30,LOW(9)
	OUT  0x12,R30
;     310         if(key==1)PORTD=0X06;
_0x36:
	CALL SUBOPT_0x18
	BRNE _0x37
	LDI  R30,LOW(6)
	OUT  0x12,R30
;     311         if(key==3)PORTD=0X05;
_0x37:
	CALL SUBOPT_0x11
	CALL SUBOPT_0x19
	BRNE _0x38
	LDI  R30,LOW(5)
	OUT  0x12,R30
;     312         if(PORTD==0X09)
_0x38:
	IN   R30,0x12
	CPI  R30,LOW(0x9)
	BRNE _0x39
;     313         {
;     314             lcd_gotoxy(0,0);
	CALL SUBOPT_0x15
;     315             lcd_putsf("chap             ");
	__POINTW1FN _0,31
	CALL SUBOPT_0x1A
;     316         }
;     317 
;     318          if(PORTD==0X06)
_0x39:
	IN   R30,0x12
	CPI  R30,LOW(0x6)
	BRNE _0x3A
;     319          {
;     320             lcd_gotoxy(0,0);
	CALL SUBOPT_0x15
;     321             lcd_putsf("rast              ");
	__POINTW1FN _0,49
	CALL SUBOPT_0x1A
;     322          }
;     323          if(PORTD==0X05)
_0x3A:
	IN   R30,0x12
	CPI  R30,LOW(0x5)
	BRNE _0x3B
;     324          {
;     325             lcd_gotoxy(0,0);
	CALL SUBOPT_0x15
;     326             lcd_putsf("stop               ");
	__POINTW1FN _0,68
	CALL SUBOPT_0x1A
;     327          }
;     328 
;     329           if(PINB.1==1)
_0x3B:
	SBIS 0x16,1
	RJMP _0x3C
;     330           {
;     331              lcd_gotoxy(0,1);
	CALL SUBOPT_0x1B
;     332              lcd_putsf("ENCOD=rast         ");
	__POINTW1FN _0,88
	CALL SUBOPT_0x1A
;     333           }
;     334 
;     335            if(PINB.1==0)
_0x3C:
	SBIC 0x16,1
	RJMP _0x3D
;     336           {
;     337               lcd_gotoxy(0,1);
	CALL SUBOPT_0x1B
;     338               lcd_putsf("ENCOD=chap          ");
	__POINTW1FN _0,108
	CALL SUBOPT_0x1A
;     339           }
;     340       }
_0x3D:
;     341     /////////////////////////
;     342      if(q==2)
_0x35:
	CALL SUBOPT_0x14
	__CPD2N 0x2
	BREQ PC+3
	JMP _0x3E
;     343      {
;     344          static unsigned char c=0;

	.DSEG

	.CSEG
;     345          if(c==0 && z>=0 && z<=9)scal=b;
	LDI  R30,LOW(0)
	CP   R30,R4
	BRNE _0x40
	CALL SUBOPT_0x1C
	BRLT _0x40
	CALL SUBOPT_0xD
	BRLT _0x41
_0x40:
	RJMP _0x3F
_0x41:
	CALL SUBOPT_0x1D
	STS  _scal,R30
	STS  _scal+1,R31
	STS  _scal+2,R22
	STS  _scal+3,R23
;     346       //////////////////////////////////////
;     347        if(c==1)
_0x3F:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x42
;     348        {
;     349         if(key==1)
	CALL SUBOPT_0x18
	BRNE _0x43
;     350      {
;     351         delay_ms(10);
	CALL SUBOPT_0x1E
;     352         if(key==1) kp=kp+1;
	CALL SUBOPT_0x18
	BRNE _0x44
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	CALL SUBOPT_0x21
;     353 
;     354      }
_0x44:
;     355     /////////
;     356      if(key==2)
_0x43:
	CALL SUBOPT_0x17
	BRNE _0x45
;     357      {
;     358         delay_ms(10);
	CALL SUBOPT_0x1E
;     359         if(key==2) kp=kp-1;
	CALL SUBOPT_0x17
	BRNE _0x46
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x22
	CALL SUBOPT_0x21
;     360 
;     361      }
_0x46:
;     362 
;     363          if( z>=0 && z<=9) kp=b;
_0x45:
	CALL SUBOPT_0x1C
	BRLT _0x48
	CALL SUBOPT_0xD
	BRLT _0x49
_0x48:
	RJMP _0x47
_0x49:
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x21
;     364 
;     365      }
_0x47:
;     366 
;     367     //////////////////////////         //////////////
;     368        if(c==2)
_0x42:
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x4A
;     369        {
;     370          if(key==1)
	CALL SUBOPT_0x18
	BRNE _0x4B
;     371      {
;     372         delay_ms(10);
	CALL SUBOPT_0x1E
;     373         if(key==1) ki=ki+1;
	CALL SUBOPT_0x18
	BRNE _0x4C
	CALL SUBOPT_0x23
	CALL SUBOPT_0x20
	CALL SUBOPT_0x24
;     374 
;     375      }
_0x4C:
;     376     ////////
;     377      if(key==2)
_0x4B:
	CALL SUBOPT_0x17
	BRNE _0x4D
;     378      {
;     379         delay_ms(10);
	CALL SUBOPT_0x1E
;     380         if(key==2)ki=ki-1;
	CALL SUBOPT_0x17
	BRNE _0x4E
	CALL SUBOPT_0x23
	CALL SUBOPT_0x22
	CALL SUBOPT_0x24
;     381 
;     382        }
_0x4E:
;     383 
;     384        if(& z>=0 && z<=9)ki=b;
_0x4D:
	LDI  R26,LOW(_z)
	LDI  R27,HIGH(_z)
	SBIW R26,0
	BRLO _0x50
	CALL SUBOPT_0xD
	BRLT _0x51
_0x50:
	RJMP _0x4F
_0x51:
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x24
;     385        }
_0x4F:
;     386       ////////////////////////////////////////////////////
;     387 
;     388        if(c==3)
_0x4A:
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x52
;     389        {
;     390         if(key==1)
	CALL SUBOPT_0x18
	BRNE _0x53
;     391      {
;     392         delay_ms(10);
	CALL SUBOPT_0x1E
;     393         if(key==1) kd=kd+1;
	CALL SUBOPT_0x18
	BRNE _0x54
	CALL SUBOPT_0x25
	CALL SUBOPT_0x20
	CALL SUBOPT_0x26
;     394 
;     395 
;     396      }
_0x54:
;     397     ////////////////
;     398      if(key==2)
_0x53:
	CALL SUBOPT_0x17
	BRNE _0x55
;     399      {
;     400         delay_ms(10);
	CALL SUBOPT_0x1E
;     401         if(key==2)kd=kd-1;
	CALL SUBOPT_0x17
	BRNE _0x56
	CALL SUBOPT_0x25
	CALL SUBOPT_0x22
	CALL SUBOPT_0x26
;     402 
;     403         }
_0x56:
;     404        if(z>=0 && z<=9)kd=b;
_0x55:
	CALL SUBOPT_0x1C
	BRLT _0x58
	CALL SUBOPT_0xD
	BRLT _0x59
_0x58:
	RJMP _0x57
_0x59:
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x26
;     405        }
_0x57:
;     406        //////////////////////////////////////////
;     407       if(key==0)c++,b=0;
_0x52:
	CALL SUBOPT_0xF
	BRNE _0x5A
	INC  R4
	CALL SUBOPT_0x27
;     408 
;     409        if(c==4)c=0;
_0x5A:
	LDI  R30,LOW(4)
	CP   R30,R4
	BRNE _0x5B
	CLR  R4
;     410 
;     411        lcd_gotoxy(0,0);
_0x5B:
	CALL SUBOPT_0x15
;     412        sprintf(str,"scal=%04d p=%03d i=%03d d=%03d",scal,kp,ki,kd);
	CALL SUBOPT_0x16
	__POINTW1FN _0,129
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x4
	CALL __PUTPARD1
	CALL SUBOPT_0x1F
	CALL __PUTPARD1
	CALL SUBOPT_0x23
	CALL __PUTPARD1
	CALL SUBOPT_0x25
	CALL __PUTPARD1
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
;     413         lcd_puts(str);
	CALL SUBOPT_0x16
	CALL _lcd_puts
;     414 
;     415 
;     416        }
;     417 
;     418      if(q==3)
_0x3E:
	CALL SUBOPT_0x14
	CALL SUBOPT_0x19
	BRNE _0x5C
;     419      {
;     420         if(key==0)b=0;
	CALL SUBOPT_0xF
	BRNE _0x5D
	CALL SUBOPT_0x27
;     421        //b=0;
;     422        if(z>=0 && z<=9)irpm=b;
_0x5D:
	CALL SUBOPT_0x1C
	BRLT _0x5F
	CALL SUBOPT_0xD
	BRLT _0x60
_0x5F:
	RJMP _0x5E
_0x60:
	CALL SUBOPT_0x1D
	STS  _irpm,R30
	STS  _irpm+1,R31
	STS  _irpm+2,R22
	STS  _irpm+3,R23
;     423        lcd_gotoxy(0,0);
_0x5E:
	CALL SUBOPT_0x15
;     424        sprintf(str,"irpm=%04d                     ",irpm);
	CALL SUBOPT_0x16
	__POINTW1FN _0,160
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x3
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;     425         lcd_puts(str);
	CALL SUBOPT_0x16
	CALL _lcd_puts
;     426 
;     427        }
;     428 
;     429 
;     430   };
_0x5C:
	RJMP _0x1A
;     431 }
_0x61:
	RJMP _0x61

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x6F
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x71
	__CPWRN 16,17,2
	BRLO _0x72
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x71:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0x28
	LDD  R26,Y+6
	STD  Z+0,R26
_0x72:
	RJMP _0x73
_0x6F:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x73:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__ftoa_G2:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x74
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x74:
	LDD  R30,Y+8
	LDI  R26,LOW(__fround_G2*2)
	LDI  R27,HIGH(__fround_G2*2)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETD1PF
	CALL SUBOPT_0x29
	CALL __ADDF12
	CALL SUBOPT_0x2A
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	CALL SUBOPT_0x2B
_0x75:
	CALL SUBOPT_0x2C
	CALL __CMPF12
	BRLO _0x77
	CALL SUBOPT_0x2D
	CALL __MULF12
	CALL SUBOPT_0x2B
	SUBI R17,-LOW(1)
	RJMP _0x75
_0x77:
	CPI  R17,0
	BRNE _0x78
	CALL SUBOPT_0x2E
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x79
_0x78:
_0x7A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x7C
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2C
	CALL __DIVF21
	CALL __CFD1
	MOV  R16,R30
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x30
	__GETD2S 2
	CALL SUBOPT_0x31
	CALL __MULF12
	CALL SUBOPT_0x29
	CALL SUBOPT_0x32
	RJMP _0x7A
_0x7C:
_0x79:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x7D
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0x178
_0x7D:
	CALL SUBOPT_0x2E
	LDI  R30,LOW(46)
	ST   X,R30
_0x7E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x80
	CALL SUBOPT_0x29
	CALL SUBOPT_0x33
	CALL SUBOPT_0x2A
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x30
	CALL SUBOPT_0x29
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	RJMP _0x7E
_0x80:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x178:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET
__ftoe_G2:
	SBIW R28,4
	CALL __SAVELOCR4
	__GETD1N 0x3F800000
	CALL SUBOPT_0x34
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x81
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x81:
	LDD  R17,Y+11
_0x82:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x84
	CALL SUBOPT_0x35
	CALL SUBOPT_0x34
	RJMP _0x82
_0x84:
	CALL SUBOPT_0x36
	CALL __CPD10
	BRNE _0x85
	LDI  R19,LOW(0)
	CALL SUBOPT_0x35
	CALL SUBOPT_0x34
	RJMP _0x86
_0x85:
	LDD  R19,Y+11
	CALL SUBOPT_0x37
	BREQ PC+2
	BRCC PC+3
	JMP  _0x87
	CALL SUBOPT_0x35
	CALL SUBOPT_0x34
_0x88:
	CALL SUBOPT_0x37
	BRLO _0x8A
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	RJMP _0x88
_0x8A:
	RJMP _0x8B
_0x87:
_0x8C:
	CALL SUBOPT_0x37
	BRSH _0x8E
	CALL SUBOPT_0x38
	CALL SUBOPT_0x33
	CALL SUBOPT_0x3A
	SUBI R19,LOW(1)
	RJMP _0x8C
_0x8E:
	CALL SUBOPT_0x35
	CALL SUBOPT_0x34
_0x8B:
	CALL SUBOPT_0x36
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x37
	BRLO _0x8F
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
_0x8F:
_0x86:
	LDI  R17,LOW(0)
_0x90:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x92
	__GETD2S 4
	__GETD1N 0x41200000
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x34
	__GETD1S 4
	CALL SUBOPT_0x38
	CALL __DIVF21
	CALL __CFD1
	MOV  R16,R30
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x30
	CALL SUBOPT_0x31
	__GETD2S 4
	CALL __MULF12
	CALL SUBOPT_0x38
	CALL __SWAPD12
	CALL __SUBF12
	CALL SUBOPT_0x3A
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x90
	CALL SUBOPT_0x3B
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x90
_0x92:
	CALL SUBOPT_0x3C
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x94
	CALL SUBOPT_0x3B
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R19
_0x94:
	CPI  R19,10
	BRLT _0x95
	CALL SUBOPT_0x3C
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
_0x95:
	CALL SUBOPT_0x3C
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
	CALL __LOADLOCR4
	ADIW R28,16
	RET
__print_G2:
	SBIW R28,63
	SBIW R28,15
	CALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 84
	STD  Y+16,R30
	STD  Y+16+1,R31
_0x96:
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	CALL SUBOPT_0x28
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x98
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x9C
	CPI  R18,37
	BRNE _0x9D
	LDI  R17,LOW(1)
	RJMP _0x9E
_0x9D:
	CALL SUBOPT_0x3D
_0x9E:
	RJMP _0x9B
_0x9C:
	CPI  R30,LOW(0x1)
	BRNE _0x9F
	CPI  R18,37
	BRNE _0xA0
	CALL SUBOPT_0x3D
	RJMP _0x17A
_0xA0:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+19,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0xA1
	LDI  R16,LOW(1)
	RJMP _0x9B
_0xA1:
	CPI  R18,43
	BRNE _0xA2
	LDI  R30,LOW(43)
	STD  Y+19,R30
	RJMP _0x9B
_0xA2:
	CPI  R18,32
	BRNE _0xA3
	LDI  R30,LOW(32)
	STD  Y+19,R30
	RJMP _0x9B
_0xA3:
	RJMP _0xA4
_0x9F:
	CPI  R30,LOW(0x2)
	BRNE _0xA5
_0xA4:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0xA6
	ORI  R16,LOW(128)
	RJMP _0x9B
_0xA6:
	RJMP _0xA7
_0xA5:
	CPI  R30,LOW(0x3)
	BRNE _0xA8
_0xA7:
	CPI  R18,48
	BRLO _0xAA
	CPI  R18,58
	BRLO _0xAB
_0xAA:
	RJMP _0xA9
_0xAB:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x9B
_0xA9:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0xAC
	LDI  R17,LOW(4)
	RJMP _0x9B
_0xAC:
	RJMP _0xAD
_0xA8:
	CPI  R30,LOW(0x4)
	BRNE _0xAF
	CPI  R18,48
	BRLO _0xB1
	CPI  R18,58
	BRLO _0xB2
_0xB1:
	RJMP _0xB0
_0xB2:
	ORI  R16,LOW(32)
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R20,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x9B
_0xB0:
_0xAD:
	CPI  R18,108
	BRNE _0xB3
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x9B
_0xB3:
	RJMP _0xB4
_0xAF:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x9B
_0xB4:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0xB9
	CALL SUBOPT_0x3E
	LDD  R30,Z+4
	CALL SUBOPT_0x3F
	RJMP _0xBA
_0xB9:
	CPI  R30,LOW(0x45)
	BREQ _0xBD
	CPI  R30,LOW(0x65)
	BRNE _0xBE
_0xBD:
	RJMP _0xBF
_0xBE:
	CPI  R30,LOW(0x66)
	BREQ PC+3
	JMP _0xC0
_0xBF:
	MOVW R30,R28
	ADIW R30,20
	STD  Y+10,R30
	STD  Y+10+1,R31
	CALL SUBOPT_0x3E
	ADIW R30,4
	MOVW R26,R30
	CALL __GETD1P
	CALL SUBOPT_0x40
	MOVW R26,R30
	MOVW R24,R22
	CALL __CPD20
	BRLT _0xC1
	LDD  R26,Y+19
	CPI  R26,LOW(0x2B)
	BREQ _0xC3
	RJMP _0xC4
_0xC1:
	CALL SUBOPT_0x41
	CALL __ANEGF1
	CALL SUBOPT_0x40
	LDI  R30,LOW(45)
	STD  Y+19,R30
_0xC3:
	SBRS R16,7
	RJMP _0xC5
	LDD  R30,Y+19
	CALL SUBOPT_0x3F
	RJMP _0xC6
_0xC5:
	CALL SUBOPT_0x42
	LDD  R26,Y+19
	STD  Z+0,R26
_0xC6:
_0xC4:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0xC8
	CALL SUBOPT_0x41
	CALL __PUTPARD1
	ST   -Y,R20
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __ftoa_G2
	RJMP _0xC9
_0xC8:
	CALL SUBOPT_0x41
	CALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ST   -Y,R31
	ST   -Y,R30
	CALL __ftoe_G2
_0xC9:
	MOVW R30,R28
	ADIW R30,20
	CALL SUBOPT_0x43
	RJMP _0xCA
_0xC0:
	CPI  R30,LOW(0x73)
	BRNE _0xCC
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x44
	CALL SUBOPT_0x43
	RJMP _0xCD
_0xCC:
	CPI  R30,LOW(0x70)
	BRNE _0xCF
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x44
	STD  Y+10,R30
	STD  Y+10+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0xCD:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0xD1
	CP   R20,R17
	BRLO _0xD2
_0xD1:
	RJMP _0xD0
_0xD2:
	MOV  R17,R20
_0xD0:
_0xCA:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+18,R30
	LDI  R19,LOW(0)
	RJMP _0xD3
_0xCF:
	CPI  R30,LOW(0x64)
	BREQ _0xD6
	CPI  R30,LOW(0x69)
	BRNE _0xD7
_0xD6:
	ORI  R16,LOW(4)
	RJMP _0xD8
_0xD7:
	CPI  R30,LOW(0x75)
	BRNE _0xD9
_0xD8:
	LDI  R30,LOW(10)
	STD  Y+18,R30
	SBRS R16,1
	RJMP _0xDA
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x3A
	LDI  R17,LOW(10)
	RJMP _0xDB
_0xDA:
	__GETD1N 0x2710
	CALL SUBOPT_0x3A
	LDI  R17,LOW(5)
	RJMP _0xDB
_0xD9:
	CPI  R30,LOW(0x58)
	BRNE _0xDD
	ORI  R16,LOW(8)
	RJMP _0xDE
_0xDD:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x11C
_0xDE:
	LDI  R30,LOW(16)
	STD  Y+18,R30
	SBRS R16,1
	RJMP _0xE0
	__GETD1N 0x10000000
	CALL SUBOPT_0x3A
	LDI  R17,LOW(8)
	RJMP _0xDB
_0xE0:
	__GETD1N 0x1000
	CALL SUBOPT_0x3A
	LDI  R17,LOW(4)
_0xDB:
	CPI  R20,0
	BREQ _0xE1
	ANDI R16,LOW(127)
	RJMP _0xE2
_0xE1:
	LDI  R20,LOW(1)
_0xE2:
	SBRS R16,1
	RJMP _0xE3
	CALL SUBOPT_0x3E
	ADIW R30,4
	MOVW R26,R30
	CALL __GETD1P
	RJMP _0x17B
_0xE3:
	SBRS R16,2
	RJMP _0xE5
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x44
	CALL __CWD1
	RJMP _0x17B
_0xE5:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x44
	CLR  R22
	CLR  R23
_0x17B:
	__PUTD1S 6
	SBRS R16,2
	RJMP _0xE7
	CALL SUBOPT_0x45
	CALL __CPD20
	BRGE _0xE8
	CALL SUBOPT_0x41
	CALL __ANEGD1
	CALL SUBOPT_0x40
	LDI  R30,LOW(45)
	STD  Y+19,R30
_0xE8:
	LDD  R30,Y+19
	CPI  R30,0
	BREQ _0xE9
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0xEA
_0xE9:
	ANDI R16,LOW(251)
_0xEA:
_0xE7:
	MOV  R19,R20
_0xD3:
	SBRC R16,0
	RJMP _0xEB
_0xEC:
	CP   R17,R21
	BRSH _0xEF
	CP   R19,R21
	BRLO _0xF0
_0xEF:
	RJMP _0xEE
_0xF0:
	SBRS R16,7
	RJMP _0xF1
	SBRS R16,2
	RJMP _0xF2
	ANDI R16,LOW(251)
	LDD  R18,Y+19
	SUBI R17,LOW(1)
	RJMP _0xF3
_0xF2:
	LDI  R18,LOW(48)
_0xF3:
	RJMP _0xF4
_0xF1:
	LDI  R18,LOW(32)
_0xF4:
	CALL SUBOPT_0x3D
	SUBI R21,LOW(1)
	RJMP _0xEC
_0xEE:
_0xEB:
_0xF5:
	CP   R17,R20
	BRSH _0xF7
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0xF8
	CALL SUBOPT_0x46
	BREQ _0xF9
	SUBI R21,LOW(1)
_0xF9:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0xF8:
	LDI  R30,LOW(48)
	CALL SUBOPT_0x3F
	CPI  R21,0
	BREQ _0xFA
	SUBI R21,LOW(1)
_0xFA:
	SUBI R20,LOW(1)
	RJMP _0xF5
_0xF7:
	MOV  R19,R17
	LDD  R30,Y+18
	CPI  R30,0
	BRNE _0xFB
_0xFC:
	CPI  R19,0
	BREQ _0xFE
	SBRS R16,3
	RJMP _0xFF
	CALL SUBOPT_0x42
	LPM  R30,Z
	RJMP _0x17C
_0xFF:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LD   R30,X+
	STD  Y+10,R26
	STD  Y+10+1,R27
_0x17C:
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	CALL __put_G2
	CPI  R21,0
	BREQ _0x101
	SUBI R21,LOW(1)
_0x101:
	SUBI R19,LOW(1)
	RJMP _0xFC
_0xFE:
	RJMP _0x102
_0xFB:
_0x104:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x45
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x106
	SBRS R16,3
	RJMP _0x107
	SUBI R18,-LOW(55)
	RJMP _0x108
_0x107:
	SUBI R18,-LOW(87)
_0x108:
	RJMP _0x109
_0x106:
	SUBI R18,-LOW(48)
_0x109:
	SBRC R16,4
	RJMP _0x10B
	CPI  R18,49
	BRSH _0x10D
	CALL SUBOPT_0x38
	CALL SUBOPT_0x9
	BRNE _0x10C
_0x10D:
	RJMP _0x10F
_0x10C:
	CP   R20,R19
	BRSH _0x17D
	CP   R21,R19
	BRLO _0x112
	SBRS R16,0
	RJMP _0x113
_0x112:
	RJMP _0x111
_0x113:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x114
_0x17D:
	LDI  R18,LOW(48)
_0x10F:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x115
	CALL SUBOPT_0x46
	BREQ _0x116
	SUBI R21,LOW(1)
_0x116:
_0x115:
_0x114:
_0x10B:
	CALL SUBOPT_0x3D
	CPI  R21,0
	BREQ _0x117
	SUBI R21,LOW(1)
_0x117:
_0x111:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x36
	CALL SUBOPT_0x45
	CALL __MODD21U
	CALL SUBOPT_0x40
	LDD  R30,Y+18
	CALL SUBOPT_0x38
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x36
	CALL __CPD10
	BREQ _0x105
	RJMP _0x104
_0x105:
_0x102:
	SBRS R16,0
	RJMP _0x118
_0x119:
	CPI  R21,0
	BREQ _0x11B
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x3F
	RJMP _0x119
_0x11B:
_0x118:
_0x11C:
_0xBA:
_0x17A:
	LDI  R17,LOW(0)
_0x9B:
	RJMP _0x96
_0x98:
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,29
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	CALL __lcd_delay_G3
	CALL __lcd_read_nibble_G3
    mov   r26,r30
	CALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R7,Y+1
	LDD  R6,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x169
	__lcd_putchar1:
	INC  R6
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R6
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x169:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R17
_0x16A:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x16C
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0x16A
_0x16C:
	LDD  R17,Y+0
	RJMP _0x177
_lcd_putsf:
	ST   -Y,R17
_0x16D:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x16F
	ST   -Y,R17
	CALL _lcd_putchar
	RJMP _0x16D
_0x16F:
	LDD  R17,Y+0
_0x177:
	ADIW R28,3
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	CALL SUBOPT_0x47
	CALL SUBOPT_0x47
	CALL SUBOPT_0x47
	CALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G3
	CALL __long_delay_G3
	LDI  R30,LOW(40)
	CALL SUBOPT_0x48
	LDI  R30,LOW(4)
	CALL SUBOPT_0x48
	LDI  R30,LOW(133)
	CALL SUBOPT_0x48
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0x170
	LDI  R30,LOW(0)
	RJMP _0x176
_0x170:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x176:
	ADIW R28,1
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S5C:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDS  R30,_rpm
	LDS  R31,_rpm+1
	LDS  R22,_rpm+2
	LDS  R23,_rpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	LDS  R30,_e1_S3
	LDS  R31,_e1_S3+1
	LDS  R22,_e1_S3+2
	LDS  R23,_e1_S3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	LDS  R30,_e0_S3
	LDS  R31,_e0_S3+1
	LDS  R22,_e0_S3+2
	LDS  R23,_e0_S3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDS  R30,_irpm
	LDS  R31,_irpm+1
	LDS  R22,_irpm+2
	LDS  R23,_irpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	LDS  R30,_scal
	LDS  R31,_scal+1
	LDS  R22,_scal+2
	LDS  R23,_scal+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5:
	LDS  R26,_pwm
	LDS  R27,_pwm+1
	LDS  R24,_pwm+2
	LDS  R25,_pwm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	STS  _pwm,R30
	STS  _pwm+1,R31
	STS  _pwm+2,R22
	STS  _pwm+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7:
	__CPD2N 0xFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	LDS  R30,_jahat_S3
	LDS  R31,_jahat_S3+1
	LDS  R22,_jahat_S3+2
	LDS  R23,_jahat_S3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x9:
	__CPD2N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	IN   R30,0x19
	ANDI R30,LOW(0xF)
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R19,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0xC:
	LDS  R26,_z
	LDS  R27,_z+1
	LDS  R24,_z+2
	LDS  R25,_z+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xD:
	RCALL SUBOPT_0xC
	__CPD2N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xF:
	LDS  R30,_key
	LDS  R31,_key+1
	LDS  R22,_key+2
	LDS  R23,_key+3
	CALL __CPD10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	LDS  R26,_key
	LDS  R27,_key+1
	LDS  R24,_key+2
	LDS  R25,_key+3
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x11:
	LDS  R26,_key
	LDS  R27,_key+1
	LDS  R24,_key+2
	LDS  R25,_key+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	__CPD2N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	LDS  R30,_q
	LDS  R31,_q+1
	LDS  R22,_q+2
	LDS  R23,_q+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x14:
	LDS  R26,_q
	LDS  R27,_q+1
	LDS  R24,_q+2
	LDS  R25,_q+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0x11
	__CPD2N 0x2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x11
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	__CPD2N 0x3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	RCALL SUBOPT_0xC
	CALL __CPD20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x1D:
	LDS  R30,_b
	LDS  R31,_b+1
	LDS  R22,_b+2
	LDS  R23,_b+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1F:
	LDS  R30,_kp
	LDS  R31,_kp+1
	LDS  R22,_kp+2
	LDS  R23,_kp+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	__ADDD1N 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x21:
	STS  _kp,R30
	STS  _kp+1,R31
	STS  _kp+2,R22
	STS  _kp+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__SUBD1N 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x23:
	LDS  R30,_ki
	LDS  R31,_ki+1
	LDS  R22,_ki+2
	LDS  R23,_ki+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x24:
	STS  _ki,R30
	STS  _ki+1,R31
	STS  _ki+2,R22
	STS  _ki+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x25:
	LDS  R30,_kd
	LDS  R31,_kd+1
	LDS  R22,_kd+2
	LDS  R23,_kd+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x26:
	STS  _kd,R30
	STS  _kd+1,R31
	STS  _kd+2,R22
	STS  _kd+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x27:
	LDI  R30,0
	STS  _b,R30
	STS  _b+1,R30
	STS  _b+2,R30
	STS  _b+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	__GETD1S 2
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	__GETD2S 2
	__GETD1N 0x41200000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2F:
	CALL __DIVF21
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	JMP  _floor

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	CALL __SWAPD12
	CALL __SUBF12
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x33:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x34:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x35:
	__GETD2S 4
	RJMP SUBOPT_0x33

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x36:
	__GETD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x37:
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x38:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x39:
	__GETD1N 0x41200000
	CALL __DIVF21
	__PUTD1S 12
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x3A:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3B:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3C:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x3D:
	ST   -Y,R18
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x3E:
	MOVW R26,R28
	SUBI R26,LOW(-(88))
	SBCI R27,HIGH(-(88))
	LD   R30,X+
	LD   R31,X+
	SBIW R30,4
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x3F:
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	__GETD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x43:
	STD  Y+10,R30
	STD  Y+10+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x44:
	ADIW R30,4
	MOVW R26,R30
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	__GETD2S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x46:
	ANDI R16,LOW(251)
	LDD  R30,Y+19
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(87))
	SBCI R31,HIGH(-(87))
	ST   -Y,R31
	ST   -Y,R30
	CALL __put_G2
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x47:
	CALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x48:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G3

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__COMD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
